#A C based version of computing the log-lik for a Gaussian Markov Mixture
#Based around the forward equations

Cver.LogLik.Gauss.MM<-function(data, theta, raw.init.vec){
#Function to perform the Forwards algorithm  on Gaussian Markov Mixutre data sequences
	#This function version uses C based code to compute the likelihood. 
	#C has been used since the for loop in R was taking some time which contributes considerably to the duration of the algorithm (more specifically, when we have lots loglik's to compute)

#data=time series under analysis
#theta=list form of the sample
#raw.init.vec= the initisation vector 

X.TP.mat<-theta[[1]] #Transition prob matrix of sample

no.rtuples<-nrow(X.TP.mat) #For a 1st order Gauss MM. This needs to change slightly if we're going to consider higher orders
rtuple.states<-colnames(X.TP.mat) #tuple names
rtuple.states.mat<-matrix(as.numeric(unlist((strsplit(rtuple.states, ",")))), nrow=no.rtuples, byrow=T) #tuples in matrix form

mu.vec<-theta[[2]] #State dependent means
prec.vec<-theta[[3]]; var.vec<- 1/prec.vec #State dependent precision and corresponding variance vector

longtheta.vec<-c(as.vector(t(X.TP.mat)), mu.vec, prec.vec)
#Vector form of the theta 	
#long version (contains ALL tps) in vector form
	#Transpose of the TP matrix is necessary due to how C deals with matrices (byrow as default), whereas R is (bycol as default)

data.T<-length(data)

dyn.load("GaussMM.so")
LogLik<-.C("GaussMMLL", as.double(data), as.integer(data.T), as.double(longtheta.vec), as.double(raw.init.vec), "li-lo"=as.double(0), "scaling"=double(data.T), as.integer(no.rtuples)) #Call the corresponding C version of the log-lik
LogLik[["li-lo"]]
#LogLik of sample in R
}
