#include <R.h>  //Used for some debuggying via R
#include <Rdefines.h> // CN addition, from R-C inteface document,
#include <Rmath.h>
#include <Rinternals.h> // RK addition
#include <R_ext/RS.h>	// RK addition
#include <R_ext/Lapack.h> // RK addition
#include <R_ext/BLAS.h> // RK addition
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <stddef.h>
#include <string.h>

//First C script which will hopefully compute the likelihood for Gaussian MM via C code

void GaussMMLL(double *data, int *ndata, double *theta, double *init_vec, double *lilo, double *scaling, int *Xsize){
//To compute the log-likelihood of a 2-state Gaussian MM
	//data= the sequence of observations
	//ndata =length of the data sequence
	//theta = set of parameters
	//init_vec = the initisation vector of the underlying MC
	//lilo = log-likelihood that we want as the output
	//scaling = vector containing scaling constants from which the log-lik is computed from
	//Xsize= The size of the underlying state space

//Objects that I need to help me
int iter; //Iterations used in the for loop
//double scaling[*ndata];  // Scaling vector storage 
double emiss_den; //Emission density variable

int nr=*Xsize; //Size of the underlying statespace, the same as Xsize. Just so I don't get confused...
 
double old_init_vec[nr]; //Storage for old 
	
// First 0:(nr^2-1) elements of theta are the transition probabilities p_{11}, p_{12},...,p_{1n}, p_{21}, ...p_{nn}
// (nr^2): (nr^2+nr-1) are the means mu_1, mu_2, ...mu_nr
// (nr^2+nr): (nr^2+2*nr-1) are the precision prec_1, prec_2, ...prec_nr

//TP mat construction
double TPmat[nr][nr]; 	
for(int i=0; i<nr; i++){ //To create a matrix given a vector of the elements
for(int j=0; j<nr; j++){
	TPmat[i][j] = theta[(nr *i)+j];
}
}	

//The actual forward equations recursion
for(iter=0; iter<*ndata; iter++) {

//Store the old forward probs from the previous time steps
	for(int i=0; i<nr; i++){
	old_init_vec[i] = init_vec[i];
	}

//Emission density vector computation
	for(int j=0; j<nr; j++){
	
emiss_den = dnorm(*(data+iter), *(theta+(nr*nr)+j), sqrt(1/ theta[nr*nr+nr+j]), 0); 
//Emission density under state j, \gamma_{j, y_{t+1}}
	//printf("Emission parameters: %f %f \n",  *(theta+(nr*nr)+j) , theta[(nr*nr)+nr+j]);
	//printf("Emission: %f \n", (float) emiss_den);

	double update=0; //the previous forward and tp matrix calculation. Needs to be reset to 0 at each iteration
for(int i=0; i <nr; i++){
update += (*(old_init_vec+i) * TPmat[i][j]); //The new unnormalised forward probability for state j
	//\sum \alpha_i * p_{i,j} 
}

*(init_vec+j) = emiss_den * update ; //The unnormalised version of the forward probabilities
	}

for(int i=0; i<nr; i++){
scaling[iter] += *(init_vec+i); // Normalising constant
}

//printf("Scaling: %f \n", (float) scaling[iter]);

for(int i =0; i<nr; i++){
*(init_vec+i) = *(init_vec+i)/scaling[iter]; //Normalised version of the forward probabilities for computational reasons
}

//printf("Normalised Forward Prob: %f %f \n", (float) init_vec[0], (float) init_vec[1]);
*lilo += (float) log(scaling[iter]); //To compute the log-likelihood
}
}


//////////////
void sum_example_cversion(data, n, sum_total)
	 double *data; /* Vector that we want to sum */
	 int *n; /* Length of the vector that we are dealing with */
	double *sum_total; /* This will provide us with the sum of the vector*/
{
// *sum_total = 0; /* Initial conditions*/

for(int iter=0; iter <*n; iter++){
*sum_total += *(data+iter);
} 
}

